'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var stringify = function stringify(val) {
  return typeof val === 'string' ? val : JSON.stringify(val);
};

var isObject = function isObject(val) {
  return val !== null && (typeof val === 'undefined' ? 'undefined' : _typeof(val)) === 'object' && val instanceof Object;
};

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var set = function set(key, val) {
  return new Promise(function (resolve) {
    if (isObject(key)) {
      var obj = key;
      Object.keys(obj).forEach(function (key) {
        return document.cookie = key + '=' + stringify(obj[val]);
      });
    } else {
      document.cookie = key + '=' + stringify(val);
    }

    resolve();
  });
};

var get = function get(key) {
  return new Promise(function (resolve) {
    var match = document.cookie.match(new RegExp('(' + key + ')=(.*?)(;|$)'));
    resolve(match ? match[2] : undefined);
  });
};

var getAll = function getAll() {
  return new Promise(function (resolve) {
    var cookies = {};
    document.cookie.replace(/; /g, ';').split(';').map(function (cookie) {
      return cookie.split('=');
    })
    // Filters only those who has a non-empty key (happens when you delete one)
    .filter(function (_ref) {
      var _ref2 = _slicedToArray(_ref, 1),
          key = _ref2[0];

      return key;
    }).forEach(function (_ref3) {
      var _ref4 = _slicedToArray(_ref3, 2),
          key = _ref4[0],
          val = _ref4[1];

      return cookies[key] = val;
    });
    resolve(cookies);
  });
};

var remove = function remove(key) {
  return new Promise(function (resolve) {
    document.cookie = key + '=; expires=Thu, 01 Jan 1970 00:00:01 GMT;';
    resolve();
  });
};

var clearAll = function clearAll() {
  return new Promise(function (resolve) {
    document.cookie.split(';').map(function (cookie) {
      return cookie.split('=')[0];
    }).forEach(remove);
    resolve();
  });
};

// Used only for tests, it's private, don't use it
var _mock = function _mock(obj) {
  Object.keys(obj).forEach(function (key) {
    document.cookie = key + '=' + stringify(obj[key]);
  });
  return Promise.resolve();
};

var _platform = 'browser';

exports.set = set;
exports.get = get;
exports.getAll = getAll;
exports.remove = remove;
exports.clearAll = clearAll;
exports._mock = _mock;
exports._platform = _platform;
