'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var reactNative = require('react-native');

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var stringify = function stringify(val) {
  return typeof val === 'string' ? val : JSON.stringify(val);
};

var isObject = function isObject(val) {
  return val !== null && (typeof val === 'undefined' ? 'undefined' : _typeof(val)) === 'object' && val instanceof Object;
};

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var set = function set(key, val) {
  if (isObject(key)) {
    var obj = key;
    var pairs = Object.keys(obj).map(function (key) {
      return [key, stringify(obj[key])];
    });

    return reactNative.AsyncStorage.multiSet(pairs);
  }

  return reactNative.AsyncStorage.setItem(key, stringify(val));
};

var get = function get(key) {
  return reactNative.AsyncStorage.getItem(key);
};

var getAll = function getAll() {
  return reactNative.AsyncStorage.getAllKeys().then(function (keys) {
    return reactNative.AsyncStorage.multiGet(keys);
  }).then(function (pairs) {
    var cookies = {};
    pairs.forEach(function (_ref) {
      var _ref2 = _slicedToArray(_ref, 2),
          key = _ref2[0],
          val = _ref2[1];

      cookies[key] = val;
    });
    return cookies;
  });
};

var remove = function remove(key) {
  return reactNative.AsyncStorage.removeItem(key);
};

var clearAll = function clearAll() {
  return reactNative.AsyncStorage.clear();
};

// Used only for tests, it's private, don't use it
var _mock = function _mock(obj) {
  var pairs = Object.keys(obj).map(function (key) {
    return [key, stringify(obj[key])];
  });
  return reactNative.AsyncStorage.multiSet(pairs);
};

var _platform = 'react native';

exports.set = set;
exports.get = get;
exports.getAll = getAll;
exports.remove = remove;
exports.clearAll = clearAll;
exports._mock = _mock;
exports._platform = _platform;
